--- old/usr/src/uts/common/fs/sockfs/sockcommon_vnops.c	2016-07-13 01:32:37.573195108 -0400
+++ new/usr/src/uts/common/fs/sockfs/sockcommon_vnops.c	2016-07-13 01:32:37.583183225 -0400
@@ -123,6 +123,9 @@
 	so->so_count++;
 	mutex_exit(&so->so_lock);
 
+	if (!(curproc->p_flag & SSYS))
+		sonode_insert_pid(so, curproc->p_pidp->pid_id);
+
 	ASSERT(so->so_count != 0);	/* wraparound */
 	ASSERT(vp->v_type == VSOCK);
 
@@ -209,6 +212,22 @@
 
 	ASSERT(vp->v_type == VSOCK);
 
+	switch (cmd) {
+	case F_ASSOCI_PID:
+		if (cr != kcred)
+			return (EPERM);
+		if (!(curproc->p_flag & SSYS))
+			sonode_insert_pid(so, (pid_t)arg);
+		return (0);
+
+	case F_DASSOC_PID:
+		if (cr != kcred)
+			return (EPERM);
+		if (!(curproc->p_flag & SSYS))
+			sonode_remove_pid(so, (pid_t)arg);
+		return (0);
+	}
+
 	return (socket_ioctl(so, cmd, arg, mode, cr, rvalp));
 }
 
